import { IWebChannelOptions } from './WebChannel';
import { WebGroup } from './WebChannelFacade';
export interface IBotOptions {
    url?: string;
    server: NodeJSHttpServer | NodeJSHttpsServer;
    perMessageDeflate?: boolean;
    leaveOnceAlone?: boolean;
    webGroupOptions?: IWebChannelOptions;
}
export declare class Bot {
    server: NodeJSHttpServer | NodeJSHttpsServer;
    perMessageDeflate: boolean;
    webGroups: Map<number, WebGroup>;
    onWebGroup: (wg: WebGroup) => void;
    onError: (err: Error) => void;
    leaveOnceAlone: boolean;
    private listenUrl;
    private webSocketServer;
    private wcOptions;
    constructor(options: IBotOptions);
    readonly url: string;
    private init();
    private validateConnection(info);
    private readUrl(url);
}
