import { BehaviorSubject, Observable } from 'rxjs';
import { Channel } from './Channel';
import { WebChannel } from './WebChannel';
export declare const CONNECT_TIMEOUT = 4000;
export declare enum Route {
    JOIN = "join",
    INVITE = "invite",
    INTERNAL = "internal",
}
export declare class WebSocketBuilder {
    static readonly listenUrl: BehaviorSubject<string>;
    private wc;
    private readonly channelsSubject;
    constructor(wc: WebChannel);
    onChannel(): Observable<Channel>;
    connectToInvite(url: string): Promise<void>;
    newInviteWebSocket(ws: WebSocket): void;
    connectToJoin(url: string, wcId: number): Promise<void>;
    newJoinWebSocket(ws: WebSocket): void;
    connectInternal(url: string, id: number): Promise<void>;
    newInternalWebSocket(ws: WebSocket, id: number): void;
    private connect(url, type, id?);
    private composeUrl(url, route, wcId?);
}
