var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { merge, Subject } from 'rxjs';
import { ChannelType } from '../../Channel';
import { isWebRTCSupported, isWebSocketSupported, log } from '../../misc/util';
import { channelBuilder as proto } from '../../proto';
import { CONNECT_TIMEOUT as WEBSOCKET_TIMEOUT, WebSocketBuilder } from '../../WebSocketBuilder';
import { CONNECT_TIMEOUT as DATACHANNEL_TIMEOUT, DataChannelBuilder, } from '../dataChannelBuilder/DataChannelBuilder';
import { Service } from '../Service';
import { PendingRequests } from './PendingRequests';
var CONNECT_TIMEOUT = Math.max(DATACHANNEL_TIMEOUT, WEBSOCKET_TIMEOUT) + 5000;
var PING_DEFAULT_TIMEOUT = 700;
var PING_MAX_TIMEOUT = 3000;
var ChannelBuilder = (function (_super) {
    __extends(ChannelBuilder, _super);
    function ChannelBuilder(wc) {
        var _this = _super.call(this, ChannelBuilder.SERVICE_ID, proto.Message) || this;
        _this.wc = wc;
        _this.allStreams = _super.prototype.useAllStreams.call(_this, wc, wc.signaling);
        _this.pendingReqs = new PendingRequests(_this.wc.STREAM_ID);
        _this.channelsSubject = new Subject();
        _this.dataChannelBuilder = new DataChannelBuilder(_this.wc, _this.wc.rtcConfiguration);
        _this.pingTimeout = PING_DEFAULT_TIMEOUT;
        _this.myInfo = {
            wsTried: false,
            wsSupported: isWebSocketSupported(),
            dcTried: false,
            dcSupported: isWebRTCSupported(),
        };
        _this.pairEncoded = _super.prototype.encode.call(_this, { pair: { initiator: _this.myInfo } });
        _this.encodePingPong();
        _this.allStreams.message.subscribe(function (_a) {
            var streamId = _a.streamId, senderId = _a.senderId, msg = _a.msg;
            _this.handleMessage(streamId, senderId, msg);
        });
        _this.subscribeToChannels();
        _this.subscribeToListenURL();
        return _this;
    }
    ChannelBuilder.prototype.clean = function () {
        this.dataChannelBuilder.clean();
        this.pendingReqs.clean();
    };
    Object.defineProperty(ChannelBuilder.prototype, "onChannel", {
        get: function () {
            return this.channelsSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    ChannelBuilder.prototype.connectOverWebChannel = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var req;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = this.pendingReqs.get(this.wc.STREAM_ID, id);
                        if (!!req) return [3, 2];
                        return [4, this.ping(id)];
                    case 1:
                        _a.sent();
                        req = this.pendingReqs.add(this.wc.STREAM_ID, id, CONNECT_TIMEOUT);
                        this.allStreams.sendOver(this.wc.STREAM_ID, this.pairEncoded, id);
                        _a.label = 2;
                    case 2: return [2, req.promise];
                }
            });
        });
    };
    ChannelBuilder.prototype.connectOverSignaling = function () {
        return __awaiter(this, void 0, void 0, function () {
            var req;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = this.pendingReqs.get(this.wc.signaling.STREAM_ID, 1);
                        if (!!req) return [3, 2];
                        return [4, this.ping(1, this.wc.signaling.STREAM_ID)];
                    case 1:
                        _a.sent();
                        req = this.pendingReqs.add(this.wc.signaling.STREAM_ID, 1, CONNECT_TIMEOUT);
                        this.allStreams.sendOver(this.wc.signaling.STREAM_ID, this.pairEncoded, 1);
                        _a.label = 2;
                    case 2: return [2, req.promise];
                }
            });
        });
    };
    ChannelBuilder.prototype.ping = function (id, streamId) {
        if (streamId === void 0) { streamId = this.wc.STREAM_ID; }
        return __awaiter(this, void 0, void 0, function () {
            var req, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        req = this.pendingReqs.getPing(streamId, id);
                        if (!req) {
                            req = this.pendingReqs.addPing(streamId, id, this.pingTimeout);
                            this.allStreams.sendOver(streamId, ChannelBuilder.pingEncoded, id);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, req.promise];
                    case 2:
                        _a.sent();
                        return [3, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new Error('ping');
                    case 4: return [2];
                }
            });
        });
    };
    ChannelBuilder.prototype.handleMessage = function (streamId, senderId, msg) {
        var _this = this;
        switch (msg.type) {
            case 'ping':
                this.allStreams.sendOver(streamId, ChannelBuilder.pongEncoded, senderId);
                break;
            case 'pong':
                this.handlePong(streamId, senderId);
                break;
            case 'pair': {
                var _a = msg.pair, initiator_1 = _a.initiator, passive_1 = _a.passive;
                if (!passive_1) {
                    var req = this.pendingReqs.get(streamId, senderId);
                    if (!req) {
                        this.pendingReqs.add(streamId, senderId, CONNECT_TIMEOUT);
                    }
                    else if (senderId < this.wc.myId) {
                        return;
                    }
                    initiator_1.id = senderId;
                    passive_1 = Object.assign({}, this.myInfo);
                    passive_1.id = streamId === this.wc.STREAM_ID ? this.wc.myId : 1;
                }
                this.proceedAlgo(streamId, initiator_1, passive_1, passive_1.id === senderId).catch(function (err) {
                    var req = _this.pendingReqs.get(streamId, senderId);
                    if (req) {
                        req.reject(err);
                    }
                    _this.allStreams.sendOver(streamId, { pair: { initiator: initiator_1, passive: passive_1 } }, senderId);
                });
            }
        }
    };
    ChannelBuilder.prototype.proceedAlgo = function (streamId, initiator, passive, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var me, theOther;
            return __generator(this, function (_a) {
                if (amIInitiator) {
                    me = initiator;
                    theOther = passive;
                }
                else {
                    me = passive;
                    theOther = initiator;
                }
                if (theOther.wss && !me.wsTried && this.tryWs(streamId, me, theOther, amIInitiator)) {
                    return [2];
                }
                if (me.wss && !theOther.wsTried) {
                    log.channelBuilder("Prompt the other to connect over WebSocket");
                    this.allStreams.sendOver(streamId, { pair: { initiator: initiator, passive: passive } }, theOther.id);
                    return [2];
                }
                if (me.dcSupported && theOther.dcSupported) {
                    if (!me.dcTried && this.tryDc(streamId, me, theOther, amIInitiator)) {
                        return [2];
                    }
                    if (!theOther.dcTried) {
                        log.channelBuilder("Prompt the other to connect over RTCDataChannel");
                        this.allStreams.sendOver(streamId, { pair: { initiator: initiator, passive: passive } }, theOther.id);
                        return [2];
                    }
                }
                log.channelBuilder("ChannelBuilder FAILED");
                throw new Error("Failed to establish a connection between " + me.id + " and " + theOther.id);
            });
        });
    };
    ChannelBuilder.prototype.tryWs = function (streamId, me, theOther, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 7, , 8]);
                        if (!(streamId === this.wc.STREAM_ID)) return [3, 2];
                        return [4, this.wc.webSocketBuilder.connectInternal(theOther.wss, theOther.id)];
                    case 1:
                        _a.sent();
                        return [3, 6];
                    case 2:
                        if (!amIInitiator) return [3, 4];
                        return [4, this.wc.webSocketBuilder.connectToJoin(theOther.wss, theOther.wcId)];
                    case 3:
                        _a.sent();
                        return [3, 6];
                    case 4: return [4, this.wc.webSocketBuilder.connectToInvite(theOther.wss)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        log.channelBuilder("New WebSocket connection with " + theOther.id);
                        return [2, true];
                    case 7:
                        err_2 = _a.sent();
                        if (err_2.message !== 'clean') {
                            log.channelBuilder("WebSocket failed with " + theOther.id, err_2);
                            me.wsTried = true;
                            return [2, false];
                        }
                        else {
                            return [2, true];
                        }
                        return [3, 8];
                    case 8: return [2];
                }
            });
        });
    };
    ChannelBuilder.prototype.tryDc = function (streamId, me, theOther, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 7, , 8]);
                        if (!(streamId === this.wc.STREAM_ID)) return [3, 2];
                        return [4, this.dataChannelBuilder.connectInternal(theOther.id)];
                    case 1:
                        _a.sent();
                        return [3, 6];
                    case 2:
                        if (!amIInitiator) return [3, 4];
                        return [4, this.dataChannelBuilder.connectToJoin(theOther.id)];
                    case 3:
                        _a.sent();
                        return [3, 6];
                    case 4: return [4, this.dataChannelBuilder.connectToInvite(theOther.id)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        log.channelBuilder("New RTCDataChannel with " + theOther.id);
                        return [2, true];
                    case 7:
                        err_3 = _a.sent();
                        if (err_3.message !== 'clean') {
                            log.channelBuilder("RTCDataChannel failed with " + theOther.id, err_3);
                            me.dcTried = true;
                            return [2, false];
                        }
                        else {
                            return [2, true];
                        }
                        return [3, 8];
                    case 8: return [2];
                }
            });
        });
    };
    ChannelBuilder.prototype.handlePong = function (streamId, id) {
        var req = this.pendingReqs.getPing(streamId, id);
        if (req) {
            req.resolve();
        }
        else {
            var created = this.pendingReqs.getCreatedDate(streamId, id);
            if (created) {
                log.channelBuilder('INCREASING Ping/Pong timeout up to: ' + this.pingTimeout);
                this.pingTimeout = Math.min(Date.now() - created + 500, PING_MAX_TIMEOUT);
            }
            else {
                log.channelBuilder('Could not find timeout request date. This message should never be shown: something is wrong.');
            }
        }
    };
    ChannelBuilder.prototype.encodePingPong = function () {
        if (!ChannelBuilder.pingEncoded && !ChannelBuilder.pongEncoded) {
            ChannelBuilder.pingEncoded = _super.prototype.encode.call(this, { ping: true });
            ChannelBuilder.pongEncoded = _super.prototype.encode.call(this, { pong: true });
        }
    };
    ChannelBuilder.prototype.subscribeToChannels = function () {
        var _this = this;
        merge(this.dataChannelBuilder.onChannel(), this.wc.webSocketBuilder.onChannel()).subscribe(function (channel) {
            channel.init.then(function () {
                var pendingReq;
                if (channel.type === ChannelType.INTERNAL) {
                    pendingReq = _this.pendingReqs.get(_this.wc.STREAM_ID, channel.id);
                }
                else if (channel.type === ChannelType.INVITED) {
                    pendingReq = _this.pendingReqs.get(_this.wc.signaling.STREAM_ID, channel.id);
                }
                else if (channel.type === ChannelType.JOINING) {
                    pendingReq = _this.pendingReqs.get(_this.wc.signaling.STREAM_ID, 1);
                }
                if (pendingReq) {
                    pendingReq.resolve();
                }
                _this.channelsSubject.next(channel);
            });
        });
    };
    ChannelBuilder.prototype.subscribeToListenURL = function () {
        var _this = this;
        WebSocketBuilder.listenUrl.subscribe(function (url) {
            if (url) {
                _this.myInfo.wss = url;
                _this.myInfo.wcId = _this.wc.id;
                _this.pairEncoded = _super.prototype.encode.call(_this, { pair: { initiator: _this.myInfo } });
            }
        });
    };
    ChannelBuilder.SERVICE_ID = 74;
    return ChannelBuilder;
}(Service));
export { ChannelBuilder };
//# sourceMappingURL=ChannelBuilder.js.map