import { Channel } from '../../Channel';
import { fullMesh as proto } from '../../proto';
import { InWcMsg, WebChannel } from '../../WebChannel';
import { ITopology, Topology } from './Topology';
export declare class FullMesh extends Topology<proto.IMessage, proto.Message> implements ITopology {
    static readonly SERVICE_ID: number;
    private adjacentMembers;
    private distantMembers;
    private membersRequestEncoded;
    private heartbeatInterval;
    private membersRequestInterval;
    constructor(wc: WebChannel);
    send(msg: InWcMsg): void;
    sendTo(msg: InWcMsg): void;
    forward(msg: InWcMsg): void;
    leave(): void;
    onChannelClose(channel: Channel): void;
    readonly neighbors: Channel[];
    private clean();
    private handleServiceMessage(channel, senderId, msg);
    private connectToMany(ids, adjacentId);
    private membersRequest();
    private notifyDistantMembers();
    private startIntervals();
    private sendToDistantPeer(distantMember, msg);
    private findRoutedChannel(distantMember, distance);
}
